#include <Keyboard.h>
class MyButton {
  public:
    int pin;
    bool pressed = false;
    String text;
    int keyCode;
    unsigned long lastTime = millis();
    int delayTime = 10; //in milli seconds
    int specialKey = false;
    
    MyButton(int pin,String text,int keyCode ) : pin(pin),text(text),keyCode(keyCode){}
    MyButton(int pin,String text,int keyCode, int delay) : pin(pin),text(text),keyCode(keyCode),delayTime(delay){}
    
    void setDelay(int delay){
      delayTime = delay;
    }
    
    bool checkButton(){
      int temp = digitalRead(pin);
      unsigned long currTime = millis();
      unsigned long delta = abs(currTime-lastTime);
      if(temp == HIGH && pressed == true&&delta > delayTime){
        pressed = false;
        Keyboard.release(keyCode);
        lastTime = millis();
        return false;
        
      }else if(temp == LOW && pressed == false && delta > delayTime) {
          pressed = true;
          lastTime = millis();
          Keyboard.press(keyCode);
          return specialKey;
      }
      if(temp == LOW && pressed == true && delta < delayTime){
            lastTime = currTime;
      }
      
      if(temp == LOW && pressed == true && specialKey) return specialKey;
      return false;
    }
};